window.Gleam.initSearch([{"doc":"grammy","title":"grammy","content":"# grammy\n\nA basic Gleam UDP server.\n\n[![Package Version](https://img.shields.io/hexpm/v/grammy)](https://hex.pm/packages/grammy)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/grammy/)\n\n```sh\ngleam add grammy\n```\n```gleam\nimport gleam/bytes_builder\nimport gleam/erlang/process\nimport gleam/int\nimport gleam/io\nimport gleam/option.{None}\nimport gleam/otp/actor\nimport gleam/string\nimport grammy\n\npub fn main() {\n  let assert Ok(_server) =\n    grammy.new(init: fn() { #(Nil, None) }, handler: fn(msg, conn, state) {\n      case msg {\n        grammy.Packet(address, port, message) -&gt; {\n          io.println(\n            grammy.ip_address_to_string(address)\n            &lt;&gt; &quot;:&quot;\n            &lt;&gt; int.to_string(port)\n            &lt;&gt; &quot; says &quot;\n            &lt;&gt; string.inspect(message),\n          )\n          let assert Ok(_nil) =\n            grammy.send_to(\n              conn,\n              address,\n              port,\n              bytes_builder.from_bit_array(message),\n            )\n          actor.continue(state)\n        }\n        grammy.User(_user) -&gt; {\n          actor.continue(state)\n        }\n      }\n    })\n    |&gt; grammy.start\n\n  process.sleep_forever()\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/grammy&gt;.\n","url":"index.html"},{"doc":"grammy","title":"Builder","content":"pub type Builder(user_state, user_message) {\n  Builder(\n    on_init: fn() -&gt;\n      #(user_state, Option(Selector(user_message))),\n    on_close: fn(user_state) -&gt; Nil,\n    port: Int,\n    handler: Handler(user_state, user_message),\n  )\n}\n\nBuilder(\n  on_init: fn() -&gt; #(user_state, Option(Selector(user_message))),\n  on_close: fn(user_state) -&gt; Nil,\n  port: Int,\n  handler: Handler(user_state, user_message),\n)\n\n\nSynonyms:\ngrammy.Builder\ngrammy Builder","url":"grammy.html#Builder"},{"doc":"grammy","title":"Connection","content":"pub opaque type Connection\n\n\nSynonyms:\ngrammy.Connection\ngrammy Connection","url":"grammy.html#Connection"},{"doc":"grammy","title":"Handler","content":"pub type Handler(user_state, user_message) =\n  fn(Message(user_message), Connection, user_state) -&gt;\n    actor.Next(user_message, user_state)\n\n\nSynonyms:\ngrammy.Handler\ngrammy Handler","url":"grammy.html#Handler"},{"doc":"grammy","title":"Message","content":"pub type Message(user_message) {\n  User(message: user_message)\n  Packet(ip_address: IpAddress, port: Int, data: BitArray)\n}\n\nUser(message: user_message)\n\n\nPacket(ip_address: IpAddress, port: Int, data: BitArray)\n\n\nSynonyms:\ngrammy.Message\ngrammy Message","url":"grammy.html#Message"},{"doc":"grammy","title":"Socket","content":"pub type Socket\n\n\nSynonyms:\ngrammy.Socket\ngrammy Socket","url":"grammy.html#Socket"},{"doc":"grammy","title":"UdpServer","content":"pub opaque type UdpServer\n\n\nSynonyms:\ngrammy.UdpServer\ngrammy UdpServer","url":"grammy.html#UdpServer"},{"doc":"grammy","title":"get_supervisor","content":"pub fn get_supervisor(server: UdpServer) -&gt; Subject(Message)\n\nSynonyms:\ngrammy.get_supervisor\ngrammy get_supervisor","url":"grammy.html#get_supervisor"},{"doc":"grammy","title":"ip_address_to_string","content":"pub fn ip_address_to_string(ip: #(Int, Int, Int, Int)) -&gt; String\n\nSynonyms:\ngrammy.ip_address_to_string\ngrammy ip_address_to_string","url":"grammy.html#ip_address_to_string"},{"doc":"grammy","title":"new","content":"pub fn new(\n  init init: fn() -&gt; #(a, Option(Selector(b))),\n  handler handler: fn(Message(b), Connection, a) -&gt; Next(b, a),\n) -&gt; Builder(a, b)\n\nSynonyms:\ngrammy.new\ngrammy new","url":"grammy.html#new"},{"doc":"grammy","title":"send_to","content":"pub fn send_to(\n  connection: Connection,\n  address: #(Int, Int, Int, Int),\n  port: Int,\n  data: BytesBuilder,\n) -&gt; Result(Nil, Nil)\n\nSynonyms:\ngrammy.send_to\ngrammy send_to","url":"grammy.html#send_to"},{"doc":"grammy","title":"start","content":"pub fn start(\n  builder: Builder(a, b),\n) -&gt; Result(UdpServer, StartError)\n\nSynonyms:\ngrammy.start\ngrammy start","url":"grammy.html#start"},{"doc":"grammy","title":"udp_send","content":"pub fn udp_send(\n  socket: Socket,\n  host: #(Int, Int, Int, Int),\n  port: Int,\n  packet: BytesBuilder,\n) -&gt; Result(Nil, Nil)\n\nSynonyms:\ngrammy.udp_send\ngrammy udp_send","url":"grammy.html#udp_send"},{"doc":"grammy","title":"grammy","content":"","url":"grammy.html"}]);